<?php
/*可擴展型自定義函數

規範如下：
==========

	(1)		FUNCTION 名稱必須為  TAR_get, 並注意大小寫
	(2)		定義採集的網站使用的編碼
			define('TARCHAR', 'UTF-8');

	(2)		最後返回一個數組，包含以下鍵值

			array(
					'subject'		=>			//視頻標題
					'image'			=>			//視頻截圖
					'flashurl'		=>			//視頻地址
					'flashid'		=>			//視頻地址識別串		可選
					'timelong'		=>			//視頻時長
					'message'		=>			//視頻簡介
					'director'		=>			//導演					可選
					'actor'			=>			//主演					可選，格式為多個可用（,）和（/）隔開
				);


*/

//定義對方網站的編碼（重中之重）
define('TARCHAR', 'UTF-8');

function TAR_get($link, $host) {
	global $_G, $p, $absidarr, $get_val_years, $get_val_address;
	$TAR_return = array();
	
	$cs = hsk_getfile($link);
	$cs = hsk_iconv($cs, TARCHAR, CHARSET);
	//处理key				http://www.56.com/u61/v_ODgzNzg1Mzg.html
	if(preg_match("/v_(.*?)\.html/i", $link, $keys)){
		$key = $keys[1];
	}else{
		preg_match("#<h3>(.*?)</h3>#is", $cs, $keys);
		preg_match("/v_(.*?)\.html/i", $keys[1], $keys);
		if(!$keys[1]){
			preg_match('#vid:"(.*?)"#is', $cs, $keys);
		}
		$key = $keys[1];
	}
	if(empty($key[1])){
		return false;
	}
	$key = "http://vxml.56.com/json/$key/?src=site";

	$c = hsk_getfile($key);
	//以上使用 視頻中心 自帶的函數 hsk_getfile 獲取數據並轉碼，下面開始判斷採集內容進行整理。

	$c = json_decode($c);
	//轉碼			$c = hsk_iconv($c, TARCHAR, CHARSET);

	$TAR_return['subject'] = hsk_iconv($c->info->Subject, TARCHAR, CHARSET);
	$TAR_return['image'] = $c->info->bimg;
	$TAR_return['flashid'] = $keys[1];
	$TAR_return['flashurl'] = "http://player.56.com/v_".$keys[1].".swf";
	$timelong = $c->info->duration;
	$timelong = substr($timelong, 0, -3);

	$TAR_return['timelong_1'] = floor($timelong/60);
	$TAR_return['timelong_2'] = $timelong%60;

	$TAR_return['tag'] = hsk_iconv($c->info->tags, TARCHAR, CHARSET);

	//視頻簡介		message
	preg_match_all("/videoinfo_l\' style=\"display:none\">(.*?)<a href=/i", $cs, $datarow);
	if(empty($datarow[1])){
		preg_match_all("#<span>简介：<\/span>(.*?)<\/p>#is", $cs, $datarow);
	}
	if(empty($datarow[1])){
		preg_match_all("/description\" content=\"(.*?)\"/i",$cs,$datarow);
	}
	$TAR_return['message'] = trim(dhtmlspecialchars(str_replace(array('&nbsp;', '<br>'), array('', ''), $datarow[1][0])));
	//以上，視頻簡介結束。

    //主演		
	$datarow = array();
	preg_match("#h_1\">演员：<\/dt>(.*?)<\/dd>#is", $cs, $datarow);
	preg_match_all("/_blank\">(.*?)<\/a>/i", $datarow[1], $datarow);
	$datarow = implode(",", $datarow[1]);
	$TAR_return['actor'] = trim(dhtmlspecialchars(str_replace(',,', ',', $datarow)));
	//以上，主演结束
	
    //导演	
	$datarow = array();	
	preg_match("#导演(.*?)<\/dd>#is", $cs, $datarow);
	preg_match_all("/_blank\">(.*?)<\/a>/i", $datarow[1], $datarow);	
	$datarow = implode(",", $datarow[1]);
	$TAR_return['director'] = trim(dhtmlspecialchars(str_replace(',,', ',', $datarow)));
	//以上，导演结束。

	//年份
	$datarow = array();
	preg_match("#<dt>上映：<\/dt>(.*?)<\/dd>#is", $cs, $datarow);
	preg_match_all("/<dd>(.*?)\-/i", $datarow[1], $datarow);
    $get_val_years = checkyears(intval($datarow[1][0]));
	//以上，视频年份结束。
	
	//地区
	$datarow = array();
	preg_match("#<dt>地区：<\/dt>(.*?)<dt>#is", $cs, $datarow);
	preg_match_all("/<dd>(.*?)<\/dd>/i", $datarow[1], $datarow);
    $TAR_return['address'] = $get_val_address = checkaddress(str_replace(array('内地', '香港', '台湾'), array('大陸', '港台', '港台'), $datarow[1][0]));
	//以上，视频地区结束。


	return  $TAR_return;
	
}

function checktype($array){
	//自动匹配影片类别
	global $_SORT, $sid;
	if(!$array) return false;

	$tmpstr = explode(",", $array);
	foreach($tmpstr as $key=>$val){
		$val = TRIM($val);
		foreach($_SORT as $sval){
			if($sval['sort'] == $val && $sval['sup'] == $sid && !in_array($val, $sidnew)){
				$sidnew[$key] = $sval['sid'];
			}
		}
	}
	RETURN ($sidnew);
}

function checkaddress($str){
	//自动匹配影片年份
	global $_ADDRESS;
	if(!$str) return false;
	foreach($_ADDRESS as $val){
		if($val['val'] == $str){
			$str = $val['key'];
		}
	}
	RETURN ($str);
}

function checkyears($str){
	//自动匹配影片年份
	global $_YEARS;
	if(!$str) return false;

	foreach($_YEARS as $val){
		if($val['val'] == $str){
			$str = $val['key'];
		}
	}
	RETURN ($str);
}
?>