<?php
/*可擴展型自定義函數

規範如下：
==========

	(1)		FUNCTION 名稱必須為  TAR_get, 並注意大小寫
	(2)		定義採集的網站使用的編碼
			define('TARCHAR', 'UTF-8');

	(2)		最後返回一個數組，包含以下鍵值

			array(
					'subject'		=>			//視頻標題
					'image'			=>			//視頻截圖
					'flashurl'		=>			//視頻地址
					'flashid'		=>			//視頻地址識別串		可選
					'timelong'		=>			//視頻時長
					'message'		=>			//視頻簡介
					'director'		=>			//導演					可選
					'actor'			=>			//主演					可選，格式為多個可用（,）和（/）隔開
					'years'			=>			//年份
					'address'		=>			//地区
					'typearray'		=>			//分类
					'abtotal'		=>			//总集数
				);


*/

//定義對方網站的編碼（重中之重）
define('TARCHAR', 'gbk');

function TAR_get($link, $host) {
	global $_G, $p, $absidarr, $get_val_years, $get_val_address;
	$TAR_return = array();

	$link = str_replace(" ", '', $link);
	$link = str_replace("\"", '', $link);
	$link = str_replace("'", '', $link);

	$c = hsk_getfile($link);
	$c = hsk_iconv($c, TARCHAR, CHARSET);
	//以上使用 視頻中心 自帶的函數 hsk_getfile 獲取數據並轉碼，下面開始判斷採集內容進行整理。

	//標題 "title": "大风水"	query="大风水"
	$datarow = array();
	if(!preg_match('#query="(.*?)"#is', $c, $datarow)){
		preg_match('#"title": "(.*?)"#is', $c, $datarow);
	}
	$TAR_return['subject'] = $datarow[1];

	//以上，標題結束
	
	//总集数
	preg_match('#"max_episode": "(\d+)"}, {"alias#is', $c, $datarow);
	$TAR_return['abtotal'] = $datarow[1];

	//圖片
	$datarow = array();
	if(!preg_match('#"poster": "(.*?)"#is', $c, $datarow)){
		preg_match('#"thumbnail": "http://(.*?)"#is', $c, $datarow);
		$datarow[1] = "http://".$datarow[1];
	}
	if(strlen($datarow[1]) > 18){
		$TAR_return['image'] = ckbaiduimg($datarow[1]);
		$TAR_return['image'] = $_G['siteurl'].$TAR_return['image'];
	}

	//以上，圖片結束。
	
	//視頻簡介
	$datarow = array();
	if(!preg_match('#"brief": "(.*?)",#is', $c, $datarow)){
		preg_match('#"brief_short": "(.*?)"#is', $c, $datarow);
	}
	$TAR_return['message'] = trim(dhtmlspecialchars($datarow[1]));
	//以上，視頻簡介結束。
	
	//年份
	$datarow = array();
	if(!preg_match('#"al_date": "(.*?)",#is', $c, $datarow)){
		preg_match('#"date": "(.*?)"#is', $c, $datarow);
	}
   $get_val_years = checkyears(intval($datarow[1]));
	//以上，視頻年份結束。
	
	//地区		"area": ["韩国"],
	$datarow = array();
	preg_match('#"area"(.*?)"],#is', $c, $datarow);
	$datarow = explode(",", $datarow[1]);
   $TAR_return['address'] = $get_val_address = checkaddress(str_replace(array(': ["', '"'), array('', ''), $datarow[0]));
	//以上，視頻地区結束。
	
	//分类
	$datarow = array();	
	preg_match('#"type"(.*?)"]#is', $c, $datarow);
   $TAR_return['typearray'] = $absidarr = checktype(str_replace(array(': ["','"'), array('',''), $datarow[1]));
   $p = count($absidarr);
   $absidarr = implode("_", $absidarr);
	//以上，視頻地区結束。
	
	//視頻時間長度		"duration": "136:00"
	preg_match('#"duration": "(\d+):(\d+)",#is', $c, $datarow);
	$TAR_return['timelong_1'] = intval($datarow[1]);
	$TAR_return['timelong_2'] = intval($datarow[2]);
	//以上是視頻時長的處理方法 ================================

    //導演		
	preg_match('#"director"(.*?)"]#is', $c, $datarow);
	$TAR_return['director'] = str_replace(': ["', '', $datarow[1]);
	//以上，導演結束。

    //主演
	preg_match('#"actor"(.*?)"]#is', $c, $datarow);
	$TAR_return['actor'] = str_replace(array(': ["','"'), array('',''), $datarow[1]);
	//以上，主演結束。
	//print_r($TAR_return);exit();
	return  $TAR_return;
}


function checktype($array){
	//自动匹配影片类别
	global $_SORT, $sid;
	if(!$array) return false;

	$tmpstr = explode(",", $array);
	foreach($tmpstr as $key=>$val){
		$val = TRIM($val);
		foreach($_SORT as $sval){
			if($sval['sort'] == $val && $sval['sup'] == $sid && !in_array($val, $sidnew)){
				$sidnew[$key] = $sval['sid'];
			}
		}
	}
	RETURN ($sidnew);
}

function checkaddress($str){
	//自动匹配影片年份
	global $_ADDRESS;
	if(!$str) return false;
	foreach($_ADDRESS as $val){
		if($val['val'] == $str){
			$str = $val['key'];
		}
	}
	RETURN ($str);
}

function checkyears($str){
	//自动匹配影片年份
	global $_YEARS;
	if(!$str) return false;

	foreach($_YEARS as $val){
		if($val['val'] == $str){
			$str = $val['key'];
		}
	}
	RETURN ($str);
}


function ckbaiduimg($var){
	$newurl = $var;
	$ch = curl_init(); 
	curl_setopt($ch, CURLOPT_URL, "$newurl"); 
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('X-FORWARDED-FOR:vod.baidu.com', 'CLIENT-IP:vod.baidu.com'));  //构造IP 
	curl_setopt($ch, CURLOPT_REFERER, "http://vod.baidu.com/ ");   //构造来路 
	curl_setopt($ch, CURLOPT_HEADER, 0); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$out = curl_exec($ch); 
	curl_close($ch); 

	$imgpath = "data/hskcenter/baiduimg/";
	if(!is_dir($imgpath))mkdir($imgpath);
	$randname = rand(10,99);
	$filename = $imgpath."baidu_".time().$randname.".jpg";
	if(@$fp = fopen("$filename", 'w')) {
		fwrite($fp, "$out");
		fclose($fp);
	}
	return $filename;
}
?>