<?php
/*可扩展型自定义函数


规范如下：
==========

	(1)		FUNCTION 名称必须为  TAR_get, 并注意大小写
	(2)		定义采集的网站使用的编码
			define('TARCHAR', 'UTF-8');

	(2)		最后返回一个数组，包含以下键值

			array(
					'subject'		=>			//视频标题
					'image'			=>			//视频截图
					'flashurl'		=>			//视频地址
					'flashid'		=>			//视频地址识别串		可选
					'timelong'		=>			//视频时长
					'message'		=>			//视频简介
					'director'		=>			//导演					可选
					'actor'			=>			//主演					可选，格式为多个可用（,）和（/）隔开
				);


*/

//定义对方网站的编码（重中之重）
define('TARCHAR', 'UTF-8');

function TAR_get($link, $host) {
    global $_G, $p, $absidarr, $get_val_years, $get_val_address;
	$TAR_return = array();
	
	$c = hsk_getfile($link);
	$c = hsk_iconv($c, TARCHAR, CHARSET);
	//以上使用 视频中心 自带的函数 hsk_getfile 获取数据并转码，下面开始判断采集内容进行整理。

	//标题		<h3 class="headline" title="		<span class="name">武侠</span>
	$datarow = array();
	preg_match("/<h3 class=\"headline\" title=\"(.*?)\">/i", $c, $datarow);
	if(empty($datarow[1][0])){
		preg_match("/<span class=\"name\">(.*?)<\/span>/i", $c, $datarow);
	}
	if(empty($datarow[1][0])){
		preg_match("/subtitle\">(.*?)<\/span>/i", $c, $datarow);
	}
	if(empty($datarow[1][0])){
		preg_match("/keywords\" content=\"(.*?)\">/i", $c, $datarow);
	}
	//转码
	$TAR_return['subject'] = $datarow[1];

	//以上，标题结束。

	//图片		<li class="thumb"><img src='http://res.mfs.ykimg.com/050E00004FAB709A97927375B50A7C65' alt='武侠'></li>
	$datarow = array();
	if(!preg_match("/&screenshot=(.*?)\"/i",$c,$datarow)){
		preg_match("/<li class=\"thumb\"><img src=\'(.*?)\' alt/i",$c,$datarow);
	}
	$TAR_return['image'] = trim(dhtmlspecialchars($datarow[1]));
	if(empty($TAR_return['image'])){
		preg_match("/http:\/\/res.mfs(.*?)\"/i",$c,$datarow);
		$TAR_return['image'] = "http://res.mfs".$datarow[1];
	}
	//以上，图片结束。

	//年份
	$datarow = array();
	preg_match("#pub\">\((.*?)\)<\/span>#is", $c, $datarow);
	if(empty($datarow)){
		preg_match("#pub\">(.*?)<\/span>#is", $c, $datarow);
	}
    $get_val_years = checkyears(intval($datarow[1]));
	//以上，视频年份结束。

	//地区
	$datarow = array();
	if(preg_match("#<label>地区:<\/label>(.*?)<\/li>#is", $c, $datarow)){
		preg_match_all("/_blank\">(.*?)<\/a>/i", $datarow[1], $datarow);
		}else{
			preg_match("#show_area\">(.*?)<\/li>#is", $c, $datarow);
			preg_match_all("/_blank\">(.*?)<\/a>/i", $datarow[1], $datarow);
		}
    $TAR_return['address'] = $get_val_address = checkaddress(str_replace(array('香港', '台湾'), array('港台', '港台'), $datarow[1][0]));
	//以上，视频地区结束。

	//分类
	$datarow = array();	
	if(preg_match('#<label>类型:<\/label>(.*?)<\/li>#is', $c, $datarow)){
	preg_match_all("/\">(.*?)<\/a>/i", $datarow[1], $datarow);
	$absidarr = implode(",", $datarow[1]);
	}
	$TAR_return['typearray'] = checktype(intval($absidarr[1]));
    $p = count($absidarr);
    $absidarr = implode("_", $absidarr);
	//以上，視頻地区結束。

	//视频地址			<li class="link"><a charset="420-2-11" href="http://v.youku.com/v_show/id_XMjk3NDgwNTgw.html"
	$datarow = array();
	if(!preg_match("/<li class=\"link\"><a(.*?)_show\/id_(.*?)[=.]/i", $c, $datarow)){
		preg_match("/target=\"_blank\"  href=\"http:\/\/v.youku.com\/v_show\/id_(.*?)[=.]/i", $c, $datarow);
		$TAR_return['flashid'] = $datarow[1];
	}else{
		$TAR_return['flashid'] = $datarow[2];
	}
	if(empty($TAR_return['flashid'])){
		preg_match("/id\_(.*?)[=.]/", $link, $datarow);
		$TAR_return['flashid'] = $datarow[1];
	}
	if(empty($TAR_return['flashid'])){
		preg_match("/var[\w\W]videoId2=[\w\W]\'(.*?)\'/", $c, $datarow);
		$TAR_return['flashid'] = $datarow[1];
	}
	if(!empty($TAR_return['flashid'])){
		$TAR_return['flashurl'] = "http://player.youku.com/player.php/sid/".$TAR_return['flashid']."/v.swf";
		$TAR_return['flashid'] = $TAR_return['flashid'];
	}
	//以上，视频地址结束。

	//此网站视频不支持获取时间长度		<label>时长:</label>115分钟							</span>
	$datarow = array();

	$timelong = 0;
	if(!preg_match("/<\/label>(.*?)分/i", $c, $datarow)){
		preg_match("#时长:<\/span>(.*?)分#is", $c, $datarow);
	}
	$timelong = intval($datarow[1])*60;

	$TAR_return['timelong_1'] = floor($timelong/60);
	$TAR_return['timelong_2'] = $timelong%60;
	//以上是视频时长的处理方法 ================================

	//视频简介		message		<div class="statdesc">		<span class="long" style="display:none;">
	$datarow = array();
	if(!preg_match("#<div class=\"statdesc\">(.*?)<\/span>#is",$c,$datarow)){
		preg_match("/item\">(.*?)<a onclick=/i",$c,$datarow);
		$TAR_return['message'] = $datarow[1];
	}else{
		$TAR_return['message'] = str_replace("<span>", '', $datarow[1]);
		$TAR_return['message'] = str_replace("\t", '', $TAR_return['message']);
	}
	if(empty($TAR_return['message'])){
		preg_match("#<span class=\"long\" style=\"display:none;\">(.*?)<\/span>#is",$c,$datarow);
		$TAR_return['message'] = $datarow[1];
	}
	
    if(empty($TAR_return['message'])){
		if(preg_match("#detail\" id=\"Detail\">(.*?)<\/div>#is", $c, $datarow)){
			preg_match_all("/block;\">(.*?)<\/span>/i", $datarow[1], $datarow);
			$TAR_return['message'] = $datarow[1][0];
		}
	}
	
	if(empty($TAR_return['message'])){
		preg_match("/description\" content=\"(.*?)\"/i",$c,$datarow);
		$TAR_return['message'] = $datarow[1];
	}
	
	if(empty($TAR_return['message'])){
		preg_match("#show_info_short\">(.*?)</span>#is",$c,$datarow);
		$TAR_return['message'] = $datarow[1];
	}
	//$TAR_return['message'] = dhtmlspecialchars($TAR_return['message']);
	//以上，视频简介结束。

	//导演
	$datarow = array();
	preg_match_all("/<li class=\"show_director\">(.*?)<\/li>/i", $c, $datarow);
	if(!empty($datarow[1])){	//继续处理	target="_blank">杜琪峰</a>
		preg_match("/target=\"_blank\">(.*?)<\/a>/i", $datarow[1][0], $datarow);
		$TAR_return['director'] = $datarow[1];
	}
	if(empty($TAR_return['director'])){
		preg_match("#<label>导演:<\/label>(.*?)target=\"_blank\">(.*?)<\/a>#is", $c, $datarow);
		$TAR_return['director'] = $datarow[2];
	}
	//以上，导演结束。

	//主演		<li class="act-avatar">
	preg_match_all("#<li class=\"act-avatar\">(.*?)<\/li>#is", $c, $datarow);
	if(!empty($datarow[1])){	//继续处理	title="玄彬"
		foreach($datarow[1] as $value){
			preg_match("/title=\"(.*?)\">/i", $value, $datarowc);
			if(!empty($datarowc[1]))
				$tmparr[] = $datarowc[1];
		}
		$TAR_return['actor'] = implode(",", $tmparr);
	}

	//<h6>演员:</h6>
	if(empty($TAR_return['actor'])){
		if(preg_match("#<h6>演员:<\/h6>(.*?)<!--.users-->#is", $c, $datarow)){
			preg_match_all("/alt=\"(.*?)\"/i", $datarow[1], $datarow);
			$TAR_return['actor'] = implode(",", $datarow[1]);
		}
	}
	if(empty($TAR_return['actor'])){
		if(preg_match_all("#<li class=\"avatar\">(.*?)<\/li>#is", $c, $datarow)){
			foreach($datarow[1] as $value){
				preg_match("/alt=\"(.*?)\"/i", $value, $datarowc);
				if(!empty($datarowc[1])){
					if($datarowc[1] == $TAR_return['director']){
						break;
					}
					$tmparr[] = $datarowc[1];
				}
			}
			$TAR_return['actor'] = implode(",", $tmparr);
		}
	}
	if(empty($TAR_return['actor'])){
		if(preg_match("#<label>主演:</label>(.*?)<\/span>	#is", $c, $datarow)){
			preg_match_all("/_blank\">(.*?)<\/a>/i", $datarow[1], $datarow);
			$TAR_return['actor'] = implode(",", $datarow[1]);
		}
	}

	//以上，主演结束。
	//print_r($TAR_return);dexit();

	return  $TAR_return;
}

function checktype($array){
	//自动匹配影片类别
	global $_SORT, $sid;
	if(!$array) return false;

	$tmpstr = explode(",", $array);
	foreach($tmpstr as $key=>$val){
		$val = TRIM($val);
		foreach($_SORT as $sval){
			if($sval['sort'] == $val && $sval['sup'] == $sid && !in_array($val, $sidnew)){
				$sidnew[$key] = $sval['sid'];
			}
		}
	}
	RETURN ($sidnew);
}

function checkaddress($str){
	//自动匹配影片年份
	global $_ADDRESS;
	if(!$str) return false;
	foreach($_ADDRESS as $val){
		if($val['val'] == $str){
			$str = $val['key'];
		}
	}
	RETURN ($str);
}

function checkyears($str){
	//自动匹配影片年份
	global $_YEARS;
	if(!$str) return false;

	foreach($_YEARS as $val){
		if($val['val'] == $str){
			$str = $val['key'];
		}
	}
	RETURN ($str);
}
?>